#ifndef ASSERTIONS_H_
#define ASSERTIONS_H_

#ifdef ASSERTIONS

#ifdef ASSERT_OUTPUT_CPP_CONSOLE

#include <iostream>

void throwExtraAssert(	const char* assertText, const char* assertDescription,
			const char* file, const char* function, int line)
{
	std::cout	<< "Expression: " << assertText << " evaluated to false." << std::endl
			<< assertDescription << std::endl
			<< "File: " << file << std::endl << "Function: " << function 
			<< " Line: " << line << std::endl;
	abort();
}

#endif

#define ASSERTION(expression,comment) { if(!(expression)) { throwExtraAssert(#expression,comment,__FILE__,__FUNCTION__,__LINE__); } }

#else

#define ASSERTION(expression,comment)

#endif

#endif /*ASSERTIONS_H_*/
