#ifndef STATICARRAY_H_
#define STATICARRAY_H_

#include "Assertions.h"

template < uint size, class T > class StaticArray
{
	private:
		T	_data[size];
	public:
		inline T operator[](uint index) const
		{
			ASSERTION(index<size,"Index is out of range")
			return _data[index];
		}

		inline T& operator[](uint index)
		{
			ASSERTION(index<size,"Index is out of range")
			return _data[index];
		}

		StaticArray<size,T>& operator = ( StaticArray<size,T>& data )
		{
			memcpy(&_data,&data._data,sizeof(T)*size);
			return *this;
		}
};

#endif
