typedef unsigned int uint;

#include "StaticArray.h"
#include "Evaluator.h"

#include <vector>
#include <cstdlib>
#include <time.h>
#include <iostream>
using namespace std;

#define INITCURRENT(d1,d2,d3,d4,d5,d6,d7,d8) current[0] = d1-1; current[1] = d2-1; current[2] = d3-1; current[3] = d4-1; current[4] = d5-1; current[5] = d6-1; current[6] = d7-1; current[7] = d8-1;

#define DUMP(var) for (uint y = 0; y < 8; y++) { for (uint x = 0; x < 8; x++) { cout << "["; if (var[x]==y) { cout << "X"; } else { cout << " "; } cout << "]"; } cout << endl; }

#define TRYMOVES() for (uint x = 0; x < 8; x++) for (uint y = 0; y < 8; y++) { if (y != current[x]) { StaticArray<8,uint> testing = current; testing[x] = y; uint value = Evaluator::Eval(testing); if (value < best) { stack.clear(); best = value; } if (value == best) { stack.push_back(testing); } } }

#define RUNMAIN() iterCount = 0; best = 40; while ((best > 0) && (iterCount < MAXITER)) { best = 40; stack.clear(); TRYMOVES() current = stack[rand()%stack.size()]; iterCount++; cout << "Best value found is: " << best << " in iteration " << iterCount << endl; DUMP(current) }

#define MAXITER 20

int main()
{

	srand((unsigned)time(NULL));

	uint best = 40; uint iterCount = 0;

	StaticArray< 8, uint > current;

	vector< StaticArray< 8, uint > > stack;

	INITCURRENT(1,6,2,5,7,4,8,3)
	cout << "Trying first variant." << endl;
	DUMP(current)
	RUNMAIN()
	cout << endl;

	INITCURRENT(4,3,2,5,4,3,2,3)
	cout << "Trying second variant." << endl;
	DUMP(current)
	RUNMAIN()
	cout << endl;


	INITCURRENT(7,4,2,5,8,6,3,1)
	cout << "Trying third variant." << endl;
	DUMP(current)
	RUNMAIN()
	cout << endl;

	cout << "Trying some random variants." << endl;

	for (uint i = 0; i < 10; i++)
	{
		INITCURRENT(rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1,rand()%8+1)
		cout << "Random variant." << endl;
		DUMP(current)
		RUNMAIN()
		cout << endl;
	}

	return 0;
}

